#! /bin/bash
# if not run in terminal, script should be run with '/bin/bash -i autocrawler.sh'

echo ""
echo "AUTOCRAWLER TOMCAT server"
echo "Use quitserver command to exit"


# set current working dir if necessary
export DIR=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )
cd $DIR

if [ -z "$CATALINA_HOME" ]; then
	export CATALINA_HOME=`pwd`;
fi


export CATALINA_OPTS="-Djava.library.path=${CATALINA_HOME}/openCVlib -Djava.security.egd=file:/dev/./urandom"

while true; do

	# update 
	if [ -d webapps/update ]; then
		echo "found update package"
		# run supplied update script
		mv webapps/update/update.sh .
		chmod u+x update.sh
		./update.sh
		rm -f update.sh
	fi

	rm -f autocrawlerrestart autocrawlerhalt
	
	# launch server 
	if [ -f "$HOME/stuff/gstreamer/gst-uninstalled.py" ]; then
		# start under uninstalled gstreamer environment
		echo "using uninstalled gstreamer"
		$HOME/stuff/gstreamer/gst-uninstalled.py ./bin/catalina.sh start 
	else 
		# use system gstreamer 
		./bin/catalina.sh start
	fi

	# get server PID  
	serverpid=`ps xa | grep '[j]ava.*autocrawler' | awk '{print $1}'`

	# loop waiting for halt file 
	while [ ! -f autocrawlerhalt ]; do sleep 1; done

	# stop server
	sleep 2
	kill $serverpid
	echo "stopping Autocrawler server"
	rm -f autocrawlerhalt
	
	#restart (continue loop) if flag exists
	if [ -f autocrawlerrestart ];	then
		echo "restarting"
		sleep 5
	else 
		echo "exiting"
		break
	fi
done

sleep 5
